SystemOrganization addCategory: #'PW-Model'!

WAUserConfiguration subclass: #PWSeasidePrefsModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Model'!

PWSeasidePrefsModel class
	instanceVariableNames: 'instance'!

!PWSeasidePrefsModel commentStamp: 'chc 3/24/2016 09:33' prior: 0!
This is a persistence model based on the Seaside preferences database. It saves data in classes called Attributes, which are saved in a custom dictionary accessable with the selectors in WAConfiguration protocols. The data is stored in a singleton backed up on image snapshot.

Create the data type with the Attribute class and add the value for it. 

| wikiString |
wikiString := 'I have some kind of string value'. 
PWSeasidePrefsModel instance takeValue: wikiString forAttribute: (WAStringAttribute key: #currentString group: #wikidata).

The data is searchable by both key and group name.

Get a key with

PWSeasidePrefsModel instance valueAt: #currentString!

PWSeasidePrefsModel class
	instanceVariableNames: 'instance'!

!PWSeasidePrefsModel class methodsFor: 'as yet unclassified' stamp: 'chc 6/23/2016 07:51'!
initializeModel
"When installed with a script there is no data in the persistence. This adds default values to the singleton."
"PWSeasidePrefsModel initializeModel"
	PWSeasidePrefsModel instance takeValue: 'off' forAttribute: (WAStringAttribute key: #render group: #wikidata).
	PWSeasidePrefsModel instance takeValue: 8624 forAttribute: (WANumberAttribute key: #port group: #server).
	PWSeasidePrefsModel instance takeValue: 'admin' forAttribute: (WAStringAttribute key: #username group: #server).
	PWSeasidePrefsModel instance takeValue: 'pegwiki' forAttribute: (WAStringAttribute key: #password group: #server).
	PWSeasidePrefsModel instance takeValue: '_ Hello San Francisco' forAttribute: (WAStringAttribute key: #currentString group: #wikidata).! !

!PWSeasidePrefsModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:22'!
instance
	^ instance ifNil: [ instance _ self basicNew initialize ]! !

!PWSeasidePrefsModel class methodsFor: 'as yet unclassified' stamp: 'chc 1/20/2016 12:23'!
new
	^ self instance! !

!PWSeasidePrefsModel methodsFor: 'as yet unclassified' stamp: 'chc 3/23/2016 09:49'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		with: (WANumberAttribute key: #port group: #server)
		with: (WAStringAttribute key: #currentString group: #wikisyntax)
		"with: (WAStringAttribute key: #render group: #authentication)"! !

TestCase subclass: #PWSeasidePrefsModelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Model'!

!PWSeasidePrefsModelTest methodsFor: 'as yet unclassified' stamp: 'chc 6/23/2016 07:58'!
testModelInitialized
"When code is loaded #PWSeasidePrefsModel class initializeModel needs to be executed (PWSeasidePrefsModel initializeModel) to give default values for PEGWiki"
	|port|
	port := PWSeasidePrefsModel instance valueAt: #port.
	self assert: (port = 8624)
! !
